/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.2 by edhill, Mon Sep 1 16:50:27 2003 UTC revision 1.130 by jmc, Mon Dec 21 00:01:06 2009 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /usr/bin/env bash
2  #  #
3  #  $Header$  #  $Header$
4    #  $Name$
5  #  #
6    
7  usage()  usage()
# Line 10  usage() Line 11  usage()
11      echo      echo
12      echo "where possible OPTIONS are:"      echo "where possible OPTIONS are:"
13      echo "  (-help|-h)               print usage"      echo "  (-help|-h)               print usage"
14      echo "  (-optfile=|-of=)STRING   list of genmake2 \"optfiles\""      echo "  (-mth)                   run multi-threaded (using eedata.mth)"
15      echo "  (-a|-addr)STRING         list of email recipients"      echo "  (-mpi)                   compile and run using MPI"
16      echo "  (-t|-tdir)STRING         list of \"test\" dirs"      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"
17        echo "                             (DEF=\"-ieee\")"
18        echo "  (-gsl)                   compile with \"-gsl\" flag"
19        echo "  (-of=|-optfile=)STRING   list of optfiles to use"
20        echo "  (-a|-addr) STRING        list of email recipients"
21        echo "                             (DEF=\"\" no email is sent)"
22        echo "  (-mpd|-mpackdir) DIR     location of the mpack utility"
23        echo "                             (DEF=\"../tools/mpack-1.6\")"
24        echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"
25        echo "                             (recognized groups: basic, tutorials)"
26        echo "                             (DEF=\"\" which test all)"
27        echo "  (-skd|-skipdir) STRING   list of exp. dirs to skip"
28        echo "                             (DEF=\"\" which test all)"
29        echo "  (-b|-bash) STRING        preferred location of a \"bash\" or"
30        echo "                             Bourne-compatible \"sh\" shell"
31        echo "                             (DEF=\"\" for \"bash\")"
32        echo "  (-adm|-ad)               perform an adjoint run"
33        echo "  (-oad)                   perform an OpenAD adjoint run"
34        echo "  (-command) STRING        command to run"
35        echo "                             (DEF=\"make output.txt\")"
36        echo "  (-m|-make) STRING        command to use for \"make\""
37        echo "                             (DEF=\"make\")"
38        echo "  (-odir) STRING           used to build output directory name"
39        echo "                             (DEF=\"hostname\")"
40        echo "  (-ptr|-ptracers) STRING  specify which ptracers to test"
41        echo "                             (DEF=\"1 2 3 4 5\")"
42        echo "  (-match) NUMBER          Matching Criteria (number of digits)"
43        echo "                             (DEF=\"12\")"
44        echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"
45        echo "  (-clean)                 *ONLY* run \"make CLEAN\""
46        echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""
47        echo "  (-nogenmake|-ng)         skip the genmake stage"
48        echo "  (-noclean|-nc)           skip the \"make clean\" stage"
49        echo "  (-nodepend|-nd)          skip the \"make depend\" stage"
50        echo "  (-deldir|-dd)            on success, delete the output directory"
51        echo "  (-ts)                    provide timing information per timestep"
52        echo "  (-papis)                 provide MFlop/s per timestep using PAPI"
53        echo "  (-pcls)                  provide MFlop/s per timestep using PCL"
54        echo
55        echo "and where STRING can be a whitespace-delimited list"
56        echo "such as:"
57        echo
58        echo "  -t 'exp0 exp2 exp3' "
59        echo "  -addr='abc@123.com testing@home.org'"
60        echo
61        echo "provided that the expression is properly quoted within the current"
62        echo "shell (note the use of single quotes to protect white space)."
63      echo      echo
64      exit 1      exit 1
65  }  }
# Line 20  usage() Line 67  usage()
67  #  build the mpack utility  #  build the mpack utility
68  build_mpack()  build_mpack()
69  {  {
70      echo -n "building the mpack utility...  "      printf "building the mpack utility...  "
71      if test ! -x "$MPACKDIR/mpack" ; then      MPACK="$MPACKDIR/mpack"
72        if test ! -x $MPACK ; then
73          if test ! -d $MPACKDIR ; then          if test ! -d $MPACKDIR ; then
74                echo
75              echo "Error: can't find \"$MPACKDIR\""              echo "Error: can't find \"$MPACKDIR\""
76              echo "  are you sure this program is being run in the correct "              echo "  are you sure this program is being run in the correct "
77              echo "  (that is, \"MITGCM_ROOT\verification\") directory?"              echo "  (that is, \"MITGCM_ROOT\verification\") directory?"
78              exit 1              echo
79                HAVE_MPACK=f
80            fi
81            if test "x$CC" = x ; then
82                export CC=cc
83          fi          fi
84          echo -n "building mpack...  "          printf "building mpack (using CC=$CC)...  "
85          ( cd $MPACKDIR && ./configure && make ) > build_mpack.out 2>&1          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1
86          RETVAL=$?          RETVAL=$?
87          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
88              echo              echo
89              echo "Error building the mpack tools at: $MPACK_DIR"              echo "Error building the mpack tools at: $MPACK_DIR"
90              exit 1              echo
91                HAVE_MPACK=f
92            else
93                rm -f tr_build_mpack.out
94                HAVE_MPACK=t
95                echo "done"
96          fi          fi
97        else
98            HAVE_MPACK=t
99            echo "already exist"
100      fi      fi
     echo "OK"  
 }  
   
 compare_lines()  
 {  
     # use codelet to compare lines  
     if [ $verbose -gt 1 ]; then  
         cat tmp3.txt 1>&2  
     fi  
     return `./a.out < tmp3.txt`  
101  }  }
102    
103  testoutput_for_prop()  testoutput_var()
104  {  {
105      # testoutput_for_prop dir s1 label subdir      # testoutput_var dir s1 label subdir reference_output
106      #      #
107      #  compares files in $dir/$subdir/output.txt and $dir/results/output.txt      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE
108      #  using search strings s1 and text label      #     with same output from reference file $dir/results/$reference_output
109        #  using search strings s1 and text label
110    
111      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
112          echo testoutput_for_prop: grep "$2" $1/$4/output.txt 1>&2          echo testoutput_var: grep "$2" $1/$4/$OUTPUTFILE 1>&2
113      fi      fi
114      if [ -r $1/$4/output.txt ]; then      if [ -r $1/$4/$OUTPUTFILE ]; then
115          grep "$2" $1/$4/output.txt | sed 's/.*=//' | nl > tmp1.txt          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > tmp1.txt
116          lncnt=`wc -l tmp1.txt | awk '{print $1}' `          lncntA=`wc -l tmp1.txt | awk '{print $1}' `
117          if [ $lncnt -lt 3 ]; then          if [ $lncntA -lt 2 ]; then
118              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
119                  echo Not enough lines of output when searching for "$2" 1>&2                  echo Not enough lines of output when searching for "$2" 1>&2
120              fi              fi
121              return 99              return 99
122          fi          fi
123      else      else
124          echo testoutput_for_prop: output.txt from model run was not readable 1>&2          echo testoutput_var: $OUTPUTFILE from model run was not readable 1>&2
125          return 99          return 99
126      fi      fi
127      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
128          echo testoutput_for_prop: grep "$2" $1/results/output.txt 1>&2          echo testoutput_var: grep "$2" $1/results/$5 1>&2
129      fi      fi
130      grep "$2" $1/results/output.txt | sed 's/.*=//' | nl > tmp2.txt      grep "$2" $1/results/$5 | sed 's/.*=//' | cat -n > tmp2.txt
131      lncnt=`wc -l tmp2.txt | awk '{print $1}' `      lncntB=`wc -l tmp2.txt | awk '{print $1}' `
132      if [ $lncnt -lt 3 ]; then      if [ $lncntB -lt 2 ]; then
133          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
134              echo Not enough lines of output when searching for "$2" 1>&2              echo Not enough lines of output when searching for "$2" 1>&2
135          fi          fi
136          return 99          return 99
137      fi      fi
138        if [ $lncntA -ne $lncntB ]; then
139            if [ $verbose -gt 0 ]; then
140                echo Not same Nb of lines when searching for "$2" ":" $lncntA $lncntB 1>&2
141            fi
142            return 99
143        fi
144        has_nan=`cat tmp1.txt | grep -i nan | wc -l`
145        if [ $has_nan -gt 0  ] ; then
146            echo testoutput_var: $OUTPUTFILE contains $has_nan NaN values  1>&2
147            return 99
148        fi
149        has_inf=`cat tmp1.txt | grep -i inf | wc -l`
150        if [ $has_inf -gt 0  ] ; then
151            echo testoutput_var: $OUTPUTFILE contains $has_inf Inf values  1>&2
152            return 99
153        fi
154      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
155          echo testoutput_for_prop: join tmp1.txt tmp2.txt 1>&2          echo testoutput_var: join tmp1.txt tmp2.txt 1>&2
156      fi      fi
157      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt
158      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
159          echo testoutput_for_prop: compare_lines 1>&2          echo testoutput_var: compare_lines 1>&2
160      fi      fi
161      compare_lines      if [ $verbose -gt 1 ]; then
162      digits_of_similarity=$?          cat tmp3.txt 1>&2
163        fi
164        echo "-1" >> tmp3.txt
165        # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number
166        cat tmp3.txt | sed -e 's|:||g' > tmp4.txt
167        digits_of_similarity=`./tr_cmpnum < tmp4.txt`
168      if [ $digits_of_similarity -eq 99 ]; then      if [ $digits_of_similarity -eq 99 ]; then
169          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
170              echo testoutput_for_prop: No comparison was available for \"$2\" 1>&2              echo testoutput_var: No comparison was available for \"$3\" 1>&2
171          fi          fi
172          digits_of_similarity=99          digits_of_similarity=99
173      else      else
174          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
175              echo There were $digits_of_similarity decimal places of similarity for \"$2\" 1>&2              echo There were $digits_of_similarity decimal places of similarity for \"$3\" 1>&2
176          fi          fi
177      fi      fi
178      rm tmp1.txt tmp2.txt tmp3.txt      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt
179            
180      return $digits_of_similarity      return $digits_of_similarity
181  }  }
182    
183  dashnum()  testoutput_run()
184  {  {
185      # dashnum n1 n2 n3 ...      # testoutput_run directory subdir reference_output
186      #      #
187      #  print numbers using %3i format or "--" if number = 99      #  test output from 1 run in "directory"
188    # --> same processing for adjoint & forward test
189            # default list of output variables to be checked:
190            #  1rst : main variable used to decide if it pass or FAIL
191            #  others : number of matching digits to be printed in summary.txt
192            listChk=$DEF_CHECK_LIST
193            #  load experiment-specific list from file "tr_checklist" (if it exist)
194            if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi
195            sVar=`echo $listChk | awk '{print $1}'`
196            # remove 1rst var and expand the list: + => min max mean s.d
197            listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \
198                                   | sed 's/+//g' | sed "s/^$sVar//"`
199            if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi
200            # check for ptracer output in reference_output file :
201            outpref=$1/results/$3
202            ptr_mon="trcstat_ptracerXX_min trcstat_ptracerXX_max"
203            ptr_mon="$ptr_mon trcstat_ptracerXX_mean trcstat_ptracerXX_sd"
204            for ii in $PTRACERS_NUM ; do
205                ptrfound=0
206                for jj in $ptr_mon ; do
207                    name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`
208                    tst=`grep $name $outpref | wc -l | awk '{print $1}'`
209                    if test ! "x$tst" = x0 ; then ptrfound=1 ; fi
210                done
211                if test $ptrfound = '1' ; then
212                    eval "HAVE_PTR0"$ii"=t"
213                else
214                    eval "HAVE_PTR0"$ii"=f"
215                  if test "x$ADM" = x -a "x$OADM" = x; then
216                  # remove this ptr from the list of output variable to check
217                  # echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2
218                    listVar=`echo "$listVar" | sed "s/ pt$ii..//g"`
219                  fi
220                fi
221            #   eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"' 1>&2
222            done
223            tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){if($i==$1)t+=1}; print t }'`
224            if test $tst != 1 ; then
225              if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2
226                     else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi
227              echo "==> WARNING: in checked list:" $listVar 1>&2
228            #- put it back once:
229              listVar=" $sVar "`echo "$listVar " | sed "s/ $sVar / /g"`
230            fi
231            if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(M)='$listVar'" 1>&2 ; fi
232            echo "listVar='$listVar'" > $CDIR"/summary.txt"
233            allargs=""
234            for xx in $listVar
235            do
236              case $xx in
237               'PS')  if [ $debug -gt 0 ]
238                      then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi
239                      testoutput_var $1 "cg2d_init_res" "Press. Solver (cg2d)" $2 $3; yy=$?
240                      if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;
241              'Cost') testoutput_var $1 "ADM  precision_derivative_cost" "ADM Cost" $2 $3; yy=$? ;;
242              'Grad') testoutput_var $1 "ADM  precision_derivative_grad" "ADM Grad" $2 $3; yy=$? ;;
243               'Tmn') testoutput_var $1 "dynstat_theta_min"  "Theta minimum"  $2 $3; yy=$? ;;
244               'Tmx') testoutput_var $1 "dynstat_theta_max"  "Theta maximum"  $2 $3; yy=$? ;;
245               'Tav') testoutput_var $1 "dynstat_theta_mean" "Theta mean"     $2 $3; yy=$? ;;
246               'Tsd') testoutput_var $1 "dynstat_theta_sd"   "Theta Std.Dev"  $2 $3; yy=$? ;;
247               'Smn') testoutput_var $1 "dynstat_salt_min"  "Salt minimum"    $2 $3; yy=$? ;;
248               'Smx') testoutput_var $1 "dynstat_salt_max"  "Salt maximum"    $2 $3; yy=$? ;;
249               'Sav') testoutput_var $1 "dynstat_salt_mean" "Salt mean"       $2 $3; yy=$? ;;
250               'Ssd') testoutput_var $1 "dynstat_salt_sd"   "Salt Std.Dev"    $2 $3; yy=$? ;;
251               'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $3; yy=$? ;;
252               'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $3; yy=$? ;;
253               'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $3; yy=$? ;;
254               'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U Std.Dev"       $2 $3; yy=$? ;;
255               'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $3; yy=$? ;;
256               'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $3; yy=$? ;;
257               'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $3; yy=$? ;;
258               'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V Std.Dev"       $2 $3; yy=$? ;;
259            'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
260               testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $3; yy=$? ;;
261            'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
262               testoutput_var $1 "trcstat_ptracer0"$ii"_max"  "p0"$ii"_max"   $2 $3; yy=$? ;;
263            'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
264               testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;
265            'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
266               testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;
267             'Qntmn') testoutput_var $1 "forcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;
268             'Qntmx') testoutput_var $1 "forcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;
269             'Qntav') testoutput_var $1 "forcing_qnet_mean" "Qnet mean"       $2 $3; yy=$? ;;
270             'Qntsd') testoutput_var $1 "forcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;
271             'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;
272             'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;
273             'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;
274             'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $3; yy=$? ;;
275             'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $3; yy=$? ;;
276             'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Heff max"   $2 $3; yy=$? ;;
277             'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Heff mean"  $2 $3; yy=$? ;;
278             'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Heff StDv"  $2 $3; yy=$? ;;
279            'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $3; yy=$? ;;
280            'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $3; yy=$? ;;
281            'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $3; yy=$? ;;
282            'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Global"    $2 $3; yy=$? ;;
283            'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South"     $2 $3; yy=$? ;;
284            'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North"     $2 $3; yy=$? ;;
285                  *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;
286              esac
287              if test $xx = $sVar
288              then allargs="$allargs > $yy <"
289              else allargs="$allargs $yy"
290              fi
291            done
292    
293            nbVar=`echo $listVar | awk '{print NF}'`
294            if [ $nbVar -lt $LEN_CHECK_LIST ] ; then
295            #-- fill line (up to standard length) with dot:
296              adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`
297              echo $allargs $adNul
298            else
299              echo $allargs
300            fi
301    # <-- same processing for adjoint & forward test
302    }
303    
304      for num in $@ ; do  genmakemodel()
305          if [ $num = 99 ]; then  {
306              printf ' --'      # genmakemodel directory
307        if test "x$NOGENMAKE" = xt ; then
308            echo "genmake skipped!"
309        else
310            if test "x$BASH" = x ; then
311                GENMAKE2="../../../tools/genmake2"
312          else          else
313              printf '%3i' $num              GENMAKE2="$BASH ../../../tools/genmake2 -bash $BASH"
314          fi          fi
315      done          (
316                cd $1;
317                command="$GENMAKE2  -ds -m $MAKE"
318                if test "x$ADM" = xt ; then
319                    command="$command --mods=../code_ad"
320                elif test "x$OADM" = xt ; then
321                    command="$command -adof ../../../tools/adjoint_options/adjoint_oad -mods '../code_oad ../../OpenAD/code_oad_all'"
322                else
323                    command="$command -mods=../code"
324                fi
325                if test "x$OPTFILE" != xNONE ; then
326                    command="$command -optfile=$OPTFILE"
327                fi
328                if test "x$IEEE" != x ; then
329                    command="$command -ieee"
330                fi
331                if test "x$GSL" = xt ; then
332                    command="$command -gsl"
333                fi
334                if test "x$MPI" = xt ; then
335                    command="$command -mpi"
336                fi
337                if test "x$MULTI_THREAD" = xt ; then
338                #- run multi-threaded using OpenMP:
339                    command="$command -omp"
340                fi
341                if test "x$TS" = xt ; then
342                    command="$command -ts"
343                fi
344                if test "x$PAPIS" = xt ; then
345                    command="$command -papis"
346                else
347                if test "x$PCLS" = xt ; then
348                    command="$command -pcls"
349                fi
350                fi
351                printf 'genmake ... ' 1>&2
352                # $command > make.log 2>&1
353                eval $command > make.log 2>&1
354                RETVAL=$?
355                #  Reduce the size of the testing emails!
356                head -100 Makefile > $CDIR/Makefile_head
357                if test "x$RETVAL" != x0 ; then
358                    tail make.log
359                    echo "genmakemodel: genmake failed" 1>&2
360                    cp genmake_* make.log $CDIR
361                    return 1
362                else
363                    echo "successful" 1>&2
364                fi
365            )
366        fi
367  }  }
368    
369  testoutput()  makeclean()
370  {  {
371      # testoutput diretory subdir      # makeclean directory
372      #      if test "x$NOCLEAN" = xt ; then
373      #  test output in "directory"          echo "make Clean skipped!"
374        else
375      if [ $debug -gt 0 ]; then          (
376          echo testoutput: testoutput_for_prop $1 cg2d_init_res 1>&2              cd $1;
377      fi              #if test -e $OUTPUTFILE ; then rm -f $OUTPUTFILE ; fi
378      testoutput_for_prop $1 "cg2d_init_res" "cg2d init. residual" $2; cg2dres=$?              if test -r Makefile ; then
379      if [ $debug -gt 0 ]; then                  printf 'clean build-dir: make Clean ... ' 2>&1
380          echo testoutput: cg2dres=$cg2dres 1>&2                  $MAKE Clean >> make.log 2>&1
381                    RETVAL=$?
382                    if test "x$RETVAL" != x0 ; then
383                        tail make.log
384                        echo "makeclean: \"make Clean\" failed" 1>&2
385                        cp make.log $CDIR"/make.log"
386                        return 1
387                    fi
388                    echo successful 1>&2
389                else
390                    echo ''
391                fi
392                exit 0
393            )
394      fi      fi
       
     testoutput_for_prop $1 "dynstat_theta_min" "theta minimum" $2; tmin=$?  
     testoutput_for_prop $1 "dynstat_theta_max" "theta maximum" $2; tmax=$?  
     testoutput_for_prop $1 "dynstat_theta_mean" "theta mean" $2; tmean=$?  
     testoutput_for_prop $1 "dynstat_theta_sd" "theta s.d." $2; tsd=$?  
     testoutput_for_prop $1 "dynstat_salt_min" "salt minimum" $2; smin=$?  
     testoutput_for_prop $1 "dynstat_salt_max" "salt maximum" $2; smax=$?  
     testoutput_for_prop $1 "dynstat_salt_mean" "salt mean" $2; smean=$?  
     testoutput_for_prop $1 "dynstat_salt_sd" "salt s.d." $2; ssd=$?  
     testoutput_for_prop $1 "dynstat_uvel_min" "U minimum" $2; umin=$?  
     testoutput_for_prop $1 "dynstat_uvel_max" "U maximum" $2; umax=$?  
     testoutput_for_prop $1 "dynstat_uvel_mean" "U mean" $2; umean=$?  
     testoutput_for_prop $1 "dynstat_uvel_sd" "U s.d." $2; usd=$?  
     testoutput_for_prop $1 "dynstat_vvel_min" "V minimum" $2; vmin=$?  
     testoutput_for_prop $1 "dynstat_vvel_max" "V maximum" $2; vmax=$?  
     testoutput_for_prop $1 "dynstat_vvel_mean" "V mean" $2; vmean=$?  
     testoutput_for_prop $1 "dynstat_vvel_sd" "V s.d." $2; vsd=$?  
       
     dashnum $cg2dres $tmin $tmax $tmean $tsd $smin $smax $smean $ssd \  
         $umin $umax $umean $usd $vmin $vmax $vmean $vsd  
395  }  }
396    
397  genmakemodel()  run_clean()
398  {  {
399      # genmakemodel directory      # run_clean directory
400      GENMAKE2="../../../tools/genmake2"      if test "x$NOCLEAN" = xt ; then
401      (          echo "run_clean skipped!"
402          cd $1;      else
403          printf 'genmake ... ' 1>&2          (
404          # ../../../tools/genmake -ieee -mods=../code > make.log 2>&1              cd $1;
405          $GENMAKE2  -ds --mods=../code "--optfile="$OPTFILE > make.log 2>&1              printf 'clean run-dir ... ' 2>&1
406          RETVAL=$?              # part of what is done after "make clean" when doing "make CLEAN"
407          for i in gm_state gm_optfile gm_local Makefile ; do              find . -name "*.meta" -exec rm {} \;
408              if test -r $i ; then              find . -name "*.data" -exec rm {} \;
409                  cp $i $CDIR              find . -name "fort.*" -exec rm {} \;
410              fi              find . -type l -exec rm {} \;
411          done              rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime
412          if test "x$RETVAL" != x0 ; then              rm -rf mnc_test_*
413              tail make.log              rm -f *_MIT_CE_000.opt0000 costfunction*0000
414              echo "genmakemodel: genmake failed" 1>&2              echo successful 1>&2
415              cp make.log $CDIR              exit 0
416              return 1          )
417          else      fi
             echo "succesful" 1>&2  
         fi  
     )  
418  }  }
419    
420  makeclean()  makedependmodel()
421  {  {
422      # makeclean directory      # makedependmodel directory
423      (      if test "x$NODEPEND" = xt ; then
424          cd $1;          echo "make depend skipped!"
425          rm -f output.txt      else
426          printf 'make CLEAN ... ' 2>&1          (
427          if test -r Makefile ; then              cd $1;
428              make CLEAN >> make.log 2>&1              printf 'make depend ... ' 1>&2
429                $MAKE depend >> make.log 2>&1
430              RETVAL=$?              RETVAL=$?
431              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
432                  tail make.log                  tail make.log
433                  echo "makeclean: \"make CLEAN\" failed" 1>&2                  echo "makedependmodel: make depend failed" 1>&2
434                  cp make.log $CDIR"/make.log"                  cp make.log $CDIR"/make.log"
435                  return 1                  return 1
436                else
437                    echo successful 1>&2
438              fi              fi
439          fi          )
440          echo succesful 1>&2      fi
         exit 0  
     )  
 }  
   
 makedependmodel()  
 {  
     # makedependmodel directory  
     (  
         cd $1;  
         printf 'make depend ... ' 1>&2  
         make depend >> make.log 2>&1  
         RETVAL=$?  
         if test "x$RETVAL" != x0 ; then  
             tail make.log  
             echo "makedependmodel: make depend failed" 1>&2  
             cp make.log $CDIR"/make.log"  
             return 1  
         else  
             echo succesful 1>&2  
         fi  
     )  
441  }  }
442    
443  makemodel()  makemodel()
# Line 231  makemodel() Line 447  makemodel()
447          cd $1;          cd $1;
448          if test -r Makefile ; then          if test -r Makefile ; then
449              printf 'make ... ' 1>&2              printf 'make ... ' 1>&2
450              make >> make.log 2>&1              if test "x$ADM" = xt ; then
451                    $MAKE adall >> make.log 2>&1
452                elif test "x$OADM" = xt ; then
453                    $MAKE adAll >> make.log 2>&1
454                else
455                    if test "x$JOBS" = x ; then
456                        $MAKE >> make.log 2>&1
457                    else
458                        $MAKE -j $JOBS >> make.log 2>&1
459                    fi
460                fi
461              RETVAL=$?              RETVAL=$?
462              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
463                  tail make.log                  tail make.log
# Line 239  makemodel() Line 465  makemodel()
465                  cp make.log $CDIR"/make.log"                  cp make.log $CDIR"/make.log"
466                  return 1                  return 1
467              else              else
468                  echo succesful 1>&2                  echo successful 1>&2
469              fi              fi
470          fi          fi
471      )      )
472  }  }
473    
474    symlink_mpifiles()
475    {
476        # Put special links so that MPI specific files are used
477        # This MUST be invoked between makeclean and makelinks because
478        # the Makefile will link to non-mpi files by default
479    
480        dir=$1
481        code_dir=$2
482        BUILD_DIR=$dir/$3
483        CODE_DIR=$dir/$code_dir
484        
485        # These are files that should replace their counter-part when using -mpi
486        MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi" -print)`
487    
488        #  Is this an MPI run?
489        if test "x$MPI" = xt ; then
490            # YES: We symbolically link these files to the build
491            # dir so long as there is no real file in place
492            for ii in $MPI_FILES ; do
493                i=`echo $ii | sed 's:^\./::'`
494                name=`echo $i | sed 's:_mpi::' `
495                cmp $CODE_DIR/$i $BUILD_DIR/$name > /dev/null 2>&1
496                RETVAL=$?
497                if test "x$RETVAL" != x0 ; then
498                    if ! test -f $BUILD_DIR/$i ; then
499                        #echo Linking $name to $i
500                        (cd $BUILD_DIR; ln -sf ../$code_dir/$i $name)
501                    fi
502                fi
503            done
504        else
505            # NO: We undo any _mpi symbolically linked files
506            for ii in $MPI_FILES ; do
507                i=`echo $ii | sed 's:^\./::'`
508                name=`echo $i | sed 's:_mpi::' `
509                if test -L $BUILD_DIR/$name ; then
510                    cmp $BUILD_DIR/$name "../$code_dir/$name"_mpi > /dev/null 2>&1
511                    RETVAL=$?
512                    if test "x$RETVAL" = x0 ; then
513                        #echo Un-linking $name from $linktarg
514                        rm -f $BUILD_DIR/$name
515                    fi
516                fi
517            done
518        fi
519        
520    }
521    
522  linkdata()  linkdata()
523  {  {
524      # linkdata flag      # linkdata run_dir input_dir_1 input_dir_2 ...
525      #      #
526      # symbolically link data files to run directory      # symbolically link data files to run directory
527      if [ $1 -ne 0 ]; then      if test -d $1 ; then
528          ( cd $2 ;  ln -sf ../input/* . )          (
529                cd $1 ; shift
530                inpMPI=`(cd ../$1 ; find . -name "*.mpi" -print | sed 's:^\./::')`
531                for xx in $inpMPI ; do
532                  if test -r "../"$1"/"$xx ; then
533                    # found 1 _mpi sfx file in 1rst input dir and it is readable
534                    yy=`echo $xx | sed 's:\.mpi$::'`
535                    if test "x$MPI" = "xt" ; then
536                    # mpi test: remove symbolic link & link _mpi sfx file
537                        if test -h $yy ; then rm -f $yy ; fi
538                        if test ! -r $yy ; then
539                            ln -sf "../"$1"/"$xx $yy ;
540                            printf "$xx " 1>&2
541                        fi
542                    else
543                    # not mpi test: remove symbolic link
544                        if test -h $yy ; then rm -f $yy ; fi
545                    fi
546                  fi
547                done
548                if test -r "../"$1"/eedata.mth" ; then
549                # found eedata.mth in 1rst input dir and it is readable
550                    if test "x$MULTI_THREAD" = "xt" ; then
551                    # multi-threaded test: remove symbolic link & link eedata.mth
552                        if test -h eedata ; then rm -f eedata ; fi
553                        if test ! -r eedata ; then
554                            ln -sf "../"$1"/eedata.mth" eedata ;
555                            printf 'eedata.mth ' 1>&2
556                        fi
557                    else
558                    # not multi-threaded test: remove eedata symbolic link
559                        if test -h eedata ; then rm -f eedata ; fi
560                    fi
561                fi
562                prevDir='NONE'
563                for ldir in $* ; do
564                    if test -d "../"$ldir -a $ldir != $prevDir ; then
565                        printf 'ldir='${ldir} 1>&2
566                        files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`
567                        for i in $files ; do
568                            if test ! -d "../"$ldir/$i ; then
569                                if test ! -r $i  ; then
570                                    printf ' '$i 1>&2
571                                    ln -sf "../"$ldir"/"$i $i
572                                fi
573                            fi
574                        done
575                        if test -x "../"$ldir"/"prepare_run ; then
576                            "../"$ldir"/"prepare_run
577                        fi
578                        printf ' ; ' 1>&2
579                    fi
580                    prevDir=$ldir
581                done
582            )
583      fi      fi
584  }  }
585    
586  runmodel()  runmodel()
587  {  {
588      # runmodel directory exe      # runmodel directory
589      #      #
590      #  runs the model "exe" in "directory" (exe is relative to directory)      #  runs "$COMMAND in "directory"
591        #  (where "$COMMAND" is relative to "directory")
592      (      (
593          cd $1          cd $1
594          if [ -x $2 ]; then          printf 'runmodel in %s ...' $1 1>&2
595              if [ $quick -eq 0 ]; then          # make output.txt
596                  rm -f output.txt          echo
597              fi          if test -L $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
598              printf 'runmodel: ' 1>&2              diff -q $EXECUTABLE "../"$builddir"/"$EXECUTABLE > /dev/null 2>&1
599              make output.txt              outD=$? ; if test $outD != 0 ; then rm -f $EXECUTABLE ; fi
600              RETVAL=$?          fi
601              if test "x$RETVAL" = x0 ; then          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
602                  cp output.txt $CDIR"/output.txt"              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp
603                  return 0              ln -sf "../"$builddir"/"$EXECUTABLE .
604            fi
605            if test ! -x $EXECUTABLE ; then
606                    rm -f $RUNLOG ; touch $RUNLOG
607                    if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
608                    echo " no executable:" $EXECUTABLE >> $RUNLOG
609                    RETVAL=8
610                    ENDVAL=-1
611            else
612                if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then
613                  # output do not exist or is older than executable:
614                    rm -f $RUNLOG ; touch $RUNLOG
615                    if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
616                    ( eval $COMMAND ) >> $RUNLOG 2>&1
617                    RETVAL=$?
618              else              else
619                  return 1                  RETVAL=0
620                    if test -f $RUNLOG ; then
621                        if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
622                        echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
623                    else
624                        touch $RUNLOG
625                        if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
626                        echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
627                        echo " no previous $RUNLOG: assume NORMAL END" >> $RUNLOG 2>&1
628                    fi
629              fi              fi
630                ENDVAL=`cat $RUNLOG | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`
631            fi
632            rm -f run.log_tmp
633            #if test "x$RETVAL" = x0 ; then
634            if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then
635                tail $RUNLOG
636                echo successful 1>&2
637                # === Reduce the size of the testing emails!
638                #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE
639                if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
640                return 0
641            else
642                tail $RUNLOG
643                echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
644                cp $RUNLOG $CDIR"/"$RUNLOG
645                if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
646                return 1
647          fi          fi
648      )      )
649  }  }
# Line 283  createcodelet() Line 652  createcodelet()
652  {  {
653      # create codelet for comparing model output      # create codelet for comparing model output
654    
655      echo -n "creating the comparison code...  "      printf "creating the comparison code (using CC=$CC)...  "
656      cat > tmp_cmpnum.f <<EOFA      cat > tr_cmpnum.c <<EOF
657        program cmpnum  #include <stdio.h>
658        implicit none  #include <math.h>
659        real*8 a,b,diff  int main( int argc, char** argv )  {
660        integer linnum,best    int linnum,cmplin,best,lncnt;
661        best=-16    double a,b,abave,relerr;
662    99  read(*,*,end=70,err=60) linnum,a,b    best = -22;
663        diff=0.5*(abs(a)+abs(b))    lncnt = 0;
664  c     print *,a,b,diff,abs(a-b)/diff    while( 1 & ( (lncnt+=1) < 999 ) )  {
665        if (diff.gt.1.e-12) then      scanf("%d", &linnum);
666          diff=abs(a-b)/diff      if (linnum == -1)  break;
667          if (diff.gt.0.) then      scanf("%lf", &a);  scanf("%lf", &b);
668  c         print *,int(log10(diff)),diff      abave = 0.5*(fabs(a)+fabs(b));
669            linnum=int(log10(diff))      if ( abave == abave ) {
670            best=max(best,linnum)        if (abave > 0.0) {
671          endif          relerr=fabs(a-b)/abave;
672        else          if (relerr > 0.0) { cmplin = (int)rint(log10(relerr)); }
673          if (best.eq.-16.and.diff.ne.0.) best=-22          else { cmplin = -16 ; }
674        endif          best = (best > cmplin) ? best : cmplin; }
675        goto 99        else { cmplin = -22 ; }
676    60  stop 'cmpnum: An error occured reading a,b'     /* printf("%d ; %lf ; %lf\n",cmplin,a,b); */
677    70  print *,-best        }
678        end     else {
679  EOFA     /* printf("%lf ; %lf ; %lf\n",abave,a,b); */
680          break; }
681      }
682      if (lncnt == 999) best=-29;
683      if (linnum != -1) best=-99;
684      printf("%d\n", -best);
685      return 0;
686    }
687    EOF
688        $CC -o tr_cmpnum tr_cmpnum.c -lm
689    
690      f77 tmp_cmpnum.f      if [ -x ./tr_cmpnum ]; then
     if [ -x ./a.out ]; then  
691          echo "OK"          echo "OK"
692          return 0          return 0
693      else      else
694          echo          echo
695          echo "createcodelet: failed to compile codelet" | tee          echo "ERROR: failed to compile comparison code -- please specify"
696            echo "  a C compiler using the CC environment variable."
697          exit 1          exit 1
698      fi      fi
699  }  }
# Line 327  formatresults() Line 705  formatresults()
705      nm=$1      nm=$1
706      printf '%s %s %s %s' $2 $3 $4 $5      printf '%s %s %s %s' $2 $3 $4 $5
707      shift; shift; shift; shift; shift;      shift; shift; shift; shift; shift;
708      printf '%3s' $@      listPrt=$@
709        listRes=`echo $listPrt | sed 's/>//' | sed 's/<//'`
710        xx=`echo $listPrt | sed 's/.*>//' | sed 's/<.*//' | awk '{print $1}'`
711        printf '%3s' $listPrt
712    #   line below does not work on hp-ux_ia64 : do those substitutions later on
713    #   printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</'
714            
715      if [ $1 = '--' ]; then      if [ $xx = '..' ]; then
716            printf ' N/O '
717        elif [ $xx = '--' ]; then
718            printf ' N/O '
719        elif [ $xx = 99 ]; then
720          printf ' N/O '          printf ' N/O '
721      else      else
722          if [ $1 -gt 12 ]; then          if [ $xx -ge $MATCH_CRIT ]; then
723              printf ' pass'              printf ' pass'
724          else          else
725              printf ' FAIL'              printf ' FAIL'
# Line 343  formatresults() Line 730  formatresults()
730            
731  }  }
732    
733  show_help()  scandirs()
734  {  {
735      cat - << EOF      if [ $# -eq 1 ]; then
736  $0 [-help] [-quick] [-verbose] dir1 [dir2] [...]          for arg in * ; do
737   -help      Show this help message              test -f $arg/$1 && echo $arg
738   -quick     Skip "genmake" and "make depend" if the Makefile exists          done
739   -quiet     Reduce the amount of output      else
740   -verbose   Produce copious amounts of output          echo $*
741   -debug     Produce even more output which will mean nothing to most      fi
  -force     Do "make CLEAN" before compiling. This forces a complete rebuild.  
  -clean     Do "make CLEAN" after compiling and testing.  
  -noieee    By default, $0 uses the -ieee option for genmake. This turns it off.  
  -cleanup   Aggresively removes all model output, executables and object files  
             and then exits. Use with care.  
   
 Normal usage:  
  $0 *       Configure, compile, run and analyze in all experiment directories  
 EOF  
742  }  }
743    
744  scandirs()  
745    check_eedata()
746  {  {
747      if [ $# -eq 0 ]; then      # check_eedata size.h eedata
748          for arg in * ; do      if [ $# -eq 2 ] ; then
749              test -d $arg/input && echo $arg        if test -f $1 -a -f $2 ; then
750          done        sx=`grep "^     & *nSx *=" $1 | sed "s/^     & *nSx *=//" | sed 's/, *$//'`
751          nx=`grep "^ *nTx *=" $2 | tail -1 | sed 's/^ *nTx *= *//' | sed "s/, *$//"`
752          if test "x$nx" = x ; then
753            rx=10
754          else
755            rx=`expr $sx % $nx`
756          fi
757          sy=`grep "^     & *nSy *=" $1 | sed "s/^     & *nSy *=//" | sed 's/, *$//'`
758          ny=`grep "^ *nTy *=" $2 | tail -1 | sed 's/^ *nTy *= *//' | sed "s/, *$//"`
759          if test "x$ny" = x ; then
760            ry=20
761          else
762            ry=`expr $sy % $ny`
763          fi
764          echo `expr $rx + $ry`
765        else
766          echo '-1'
767          fi
768      else      else
769          echo $*        echo '-2'
770      fi      fi
 }  
771    
772    }
773    
774  ###############################################################################  ###############################################################################
 ###############################################################################  
 ###############################################################################  
775    
776    
777  #  Default properties  #  Default properties
778  debug=0  debug=0
779  verbose=1  verbose=1
 quick=0  
780  clean=0  clean=0
 ieee=1  
 expts=''  
781    
782  OPTFILES=  IEEE=true
783  ADDRESSES=edhill@mitgcm.org  if test "x$MITGCM_IEEE" != x ; then
784        IEEE=$MITGCM_IEEE
785    fi
786    GSL=f
787    
788    CLEANUP=f
789    QUICK=f
790    NOGENMAKE=f
791    NOCLEAN=f
792    NODEPEND=f
793    POSTCLEAN=f
794    
795    BASH=
796    OPTFILE=NONE
797    ADDRESSES=
798  TESTDIRS=  TESTDIRS=
799    SKIPDIRS=
800  MPACKDIR="../tools/mpack-1.6"  MPACKDIR="../tools/mpack-1.6"
801  MPACK="$MPACKDIR/mpack"  HAVE_MPACK=
802    MPACK=
803    COMMAND=
804    if test "x$MAKE" = x ; then
805        MAKE=make
806    fi
807    if test "x$CC" = x ; then
808        CC=cc
809    fi
810    JOBS=
811    MPI=f
812    MULTI_THREAD=f
813    OUTDIR=
814    DELDIR=
815    
816    ADM=
817    OADM=
818    
819    # list of pTracers to check for monitor output
820    PTRACERS_NUM="1 2 3 4 5"
821    
822  echo -n "parsing options...  "  MATCH_CRIT=13
823    
824    printf "parsing options...  "
825    
826  ac_prev=  ac_prev=
827  for ac_option ; do  for ac_option ; do
# Line 414  for ac_option ; do Line 841  for ac_option ; do
841              usage ;;              usage ;;
842                    
843          -optfile | --optfile | -of | --of)          -optfile | --optfile | -of | --of)
844              ac_prev=OPTFILES ;;              ac_prev=OPTFILE ;;
845          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
846              OPTFILES=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
847                    
848          -addr | --addr | -a | --a)          -addr | --addr | -a | --a)
849              ac_prev=ADDRESSES ;;              ac_prev=ADDRESSES ;;
850          -addr=* | --addr=*)          -addr=* | --addr=*)
851              ADDRESSES=$ac_optarg ;;              ADDRESSES=$ac_optarg ;;
852            -mpackdir | --mpackdir | -mpd | --mpd)
853                ac_prev=MPACKDIR ;;
854            -mpackdir=* | --mpackdir=* | -mpd=* | --mpd=*)
855                MPACKDIR=$ac_optarg ;;
856    
857          -tdir | --tdir | -t | --t)          -tdir | --tdir | -t | --t)
858              ac_prev=TESTDIRS ;;              ac_prev=TESTDIRS ;;
859          -tdir=* | --tdir=*)          -tdir=* | --tdir=*)
860              TESTDIRS=$ac_optarg ;;              TESTDIRS=$ac_optarg ;;
861    
862          -quick) quick=1 ;;          -skipdir | --skipdir | -skd | --skd)
863                ac_prev=SKIPDIRS ;;
864            -skipdir=* | --skipdir=*)
865                SKIPDIRS=$ac_optarg ;;
866    
867            -bash | --bash | -b | --b)
868                ac_prev=BASH ;;
869            -bash=* | --bash=*)
870                BASH=$ac_optarg ;;
871    
872            -command | --command | -c | --c)
873                ac_prev=COMMAND ;;
874            -command=* | --command=*)
875                COMMAND=$ac_optarg ;;
876    
877            -make | --make | -m | --m)
878                ac_prev=MAKE ;;
879            -make=* | --make=*)
880                MAKE=$ac_optarg ;;
881    
882            -odir | --odir)
883                ac_prev=OUTDIR ;;
884            -odir=* | --odir=*)
885                OUTDIR=$ac_optarg ;;
886    
887            -ptracers | --ptracers | -ptr | --ptr)
888                ac_prev=PTRACERS_NUM ;;
889            -ptracers=* | --ptracers=* | -ptr=* | --ptr=*)
890                PTRACERS_NUM=$ac_optarg ;;
891    
892            -match | --match ) ac_prev=MATCH_CRIT ;;
893            -match=* | --match=* ) MATCH_CRIT=$ac_optarg ;;
894    
895            -j) ac_prev=JOBS ;;
896            -j=*) JOBS=$ac_optarg ;;
897    
898            -clean | --clean)
899                CLEANUP=t ; DELDIR=t ;;
900    
901            -quick | --quick | -q | --q)
902                QUICK=t ;;
903            -nogenmake | --nogenmake | -ng | --ng)
904                NOGENMAKE=t ;;
905            -noclean | --noclean | -nc | --nc)
906                NOCLEAN=t ;;
907            -nodepend | --nodepend | -nd | --nd)
908                NODEPEND=t ;;
909    
910            -postclean | --postclean | -pc | --pc)
911                POSTCLEAN=t ;;
912    
913            -mpi) MPI=t ;;
914    
915            -mth) MULTI_THREAD=t ;;
916    
917            -adm | -ad) ADM=t ;;
918    
919            -oad) OADM=t; NODEPEND=t ;;
920    
921            -ieee) IEEE=true ;;
922            -noieee) IEEE= ;;
923            -gsl) GSL=t ;;
924    
925          -verbose) verbose=2 ;;          -verbose) verbose=2 ;;
926          -debug) debug=1 ;;          -debug) debug=1 ;;
         -clean) clean=1 ;;  
         -noieee) ieee=0 ;;  
927          -quiet) verbose=0 ;;          -quiet) verbose=0 ;;
928    
929            -deldir | -dd) DELDIR=t ;;
930    
931            -ts) TS=t;;
932    
933            -papis) PAPIS=t;;
934    
935            -pcls) PCL=t;;
936    
937          -*)          -*)
938              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
939              usage              usage
# Line 449  for ac_option ; do Line 948  for ac_option ; do
948            
949  done  done
950    
951    if test "x$QUICK" = xt ; then
952        NOGENMAKE=t
953        NOCLEAN=t
954        NODEPEND=t
955    fi
956    
957    #- setting for forward or ADM testing
958    if test "x$ADM" = xt ; then
959        code_dir=code_ad
960        inputdir=input_ad
961        ref_outp="output_adm.txt"
962        EXECUTABLE="mitgcmuv_ad"
963    elif test "x$OADM" = xt ; then
964        code_dir=code_oad
965        inputdir=input_oad
966        ref_outp="output_oadm.txt"
967        EXECUTABLE="mitgcmuv_ad"
968    else
969        code_dir=code
970        inputdir=input
971        ref_outp="output.txt"
972        EXECUTABLE="mitgcmuv"
973    fi
974    
975  if test "x$TESTDIRS" = x ; then  if test "x$TESTDIRS" = x ; then
976      TESTDIRS=`scandirs`      LIST=`scandirs results/$ref_outp`
977    else
978        #- expand group of experiments:
979        LIST=" "
980        for xx in $TESTDIRS
981        do
982          case $xx in
983            'basic') LIST=${LIST}" aim.5l_cs hs94.128x64x5 ideal_2D_oce"
984                     LIST=${LIST}" lab_sea tutorial_baroclinic_gyre"
985                     LIST=${LIST}" tutorial_global_oce_latlon tutorial_plume_on_slope"
986                    ;;
987            'tutorials')
988                     LIST=${LIST}" "`ls | grep 'tutorial_'` ;;
989            *)       LIST=${LIST}" "$xx ;;
990          esac
991        done
992    fi
993    #echo 'LIST='${LIST}'<'
994    #- skip dirs, remove duplicate and non-directory:
995    TESTDIRS=" "
996    count=0
997    for xx in $LIST
998    do
999        yy=`echo $SKIPDIRS | grep -c $xx`
1000        if test $yy = 0 ; then
1001            if test -d $xx ; then
1002                yy=`echo $TESTDIRS | grep -c $xx`
1003                if test $yy = 0 ; then TESTDIRS=${TESTDIRS}" "$xx ; fi
1004            else count=1 ;
1005                echo ""; echo -n " -- skip \"$xx\" (not a directory !)"
1006            fi
1007        else
1008            if test $count = 1 ; then echo -n ", \"$xx\""
1009            else count=1 ; echo "" ;  echo -n " skip: \"$xx\""
1010            fi
1011        fi
1012    done
1013    if test $count = 1 ; then echo "" ; echo -n " ... " ; fi
1014    #echo 'TESTDIRS='${TESTDIRS}'<'
1015    
1016    if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then
1017        OPTFILE=$MITGCM_OF
1018  fi  fi
1019    
1020  echo "OK"  RUNLOG="run.log"
1021    OUTPUTFILE=$ref_outp
1022    if test "x$COMMAND" = x ; then
1023        COMMAND="./$EXECUTABLE > $OUTPUTFILE"
1024    fi
1025    if test "x$MPI" = xt ; then
1026        OUTPUTFILE="STDOUT.0000"
1027    fi
1028    
1029    echo "OK (COMMAND= $COMMAND )"
1030    
1031    # set the Default List of output variables to be checked:
1032    #  (use default or load experiment-specific list from file "tr_checklist")
1033    # content : 1rst = main variable used to decide if it pass or FAIL
1034    #         others = number of matching digits to be printed in summary.txt
1035    if test "x$ADM" = x -a "x$OADM" = x; then
1036        DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'
1037        EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'
1038        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1039        ii=`echo $EMPTY_RESULTS | awk '{print NF}'`
1040        EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`
1041    else
1042        DEF_CHECK_LIST='Grad Cost Grad'
1043        EMPTY_RESULTS='.. ..'
1044        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1045    fi
1046    
1047  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
1048  createcodelet  createcodelet
1049    
1050  #  build the mpack utility  #  build the mpack utility (if ADDRESSES = NONE, do it to test the build)
1051  build_mpack  if test "x$ADDRESSES" = x ; then
1052        echo "skipping mpack build"
1053    else
1054        build_mpack
1055    fi
1056    
1057  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
1058    CMDLINE=$0
1059    for xx in "$@" ; do nw=`echo $xx | wc -w`
1060        if test $nw = '1' ; then CMDLINE="$CMDLINE $xx"
1061                            else CMDLINE="$CMDLINE '$xx'" ; fi
1062    done
1063    #for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done
1064  MACH=`hostname`  MACH=`hostname`
1065  UNAMEA=`uname -a`  UNAMEA=`uname -a`
1066  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
1067  BASE=$MACH"_"$DATE"_"  BASE="tr_"$MACH"_"$DATE"_"
1068    if test "x$OUTDIR" != x ; then
1069        BASE="tr_"$OUTDIR"_"$DATE"_"
1070    else
1071        short_name=`hostname | sed 's/\..*$//'`
1072        BASE="tr_"$short_name"_"$DATE"_"
1073    fi
1074  DNUM=0  DNUM=0
1075  DRESULTS="$BASE$DNUM"  DRESULTS="$BASE$DNUM"
1076  while test -e $DRESULTS ; do  while test -e $DRESULTS ; do
# Line 475  done Line 1080  done
1080  mkdir $DRESULTS  mkdir $DRESULTS
1081  RETVAL=$?  RETVAL=$?
1082  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
1083      echo "Error: can't create results directory \"./$DRESULTS\""      echo "ERROR: Can't create results directory \"./$DRESULTS\""
1084      exit 1      exit 1
1085  fi  fi
1086  SUMMARY="$DRESULTS/summary.txt"  SUMMARY="$DRESULTS/summary.txt"
1087  date > $SUMMARY  start_date=`date`
1088  cat << EOF >> $SUMMARY  echo $start_date > $SUMMARY
1089                  T           S           U           V  echo 'run:' $CMDLINE >> $SUMMARY
1090  G D M    c        m  s        m  s        m  s        m  s  echo 'on :' $UNAMEA  >> $SUMMARY
1091  E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  .  
1092  N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d  of_path=
1093  2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  .  if test "x$OPTFILE" != xNONE ; then
1094        if test -r $OPTFILE ; then
1095            # get the path
1096            path=${OPTFILE%/*}
1097            if test "x$path" = x ; then
1098                of_path=`pwd`
1099            else
1100                of_path=`( cd $path > /dev/null 2>&1 ; pwd )`
1101            fi
1102            file=${OPTFILE##*/}
1103            OPTFILE=$of_path/$file
1104            cp $OPTFILE $DRESULTS
1105            echo >> $SUMMARY
1106            echo "  OPTFILE=$OPTFILE" >> $SUMMARY
1107        else
1108            echo | tee $SUMMARY
1109            echo "ERROR: can't read OPTFILE=\"$OPTFILE\"" | tee $SUMMARY
1110            exit 1
1111        fi
1112    else
1113        echo >> $SUMMARY
1114        echo "No \"OPTFILE\" was explicitly specified by testreport," >> $SUMMARY
1115        echo "   so the genmake default will be used." >> $SUMMARY
1116    fi
1117    echo
1118    echo >> $SUMMARY
1119    if test "x$ADM" = x -a "x$OADM" = x; then
1120        if [ $MATCH_CRIT -lt 10 ] ;
1121        then line_0="default  "$MATCH_CRIT ;
1122        else line_0="default "$MATCH_CRIT ; fi
1123           line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"
1124    #   line_0="            ----T-----  ----S-----  ----U-----  ----V-----"
1125        line_1="G D M    c        m  s        m  s        m  s        m  s"
1126        line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."
1127        line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"
1128        line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."
1129        for ii in $PTRACERS_NUM ; do
1130            line_0="$line_0  --PTR 0"$ii"--"
1131            line_1="$line_1        m  s"
1132            line_2="$line_2  m  m  e  ."
1133            line_3="$line_3  i  a  a  d"
1134            line_4="$line_4  n  x  n  ."
1135        done
1136        echo "$line_0" | tee -a $SUMMARY
1137        echo "$line_1" | tee -a $SUMMARY
1138        echo "$line_2" | tee -a $SUMMARY
1139        echo "$line_3" | tee -a $SUMMARY
1140        echo "$line_4" | tee -a $SUMMARY
1141        echo " "       | tee -a $SUMMARY
1142    else
1143        echo "ADJOINT=true" >> $SUMMARY
1144        echo >> $SUMMARY
1145        if [ $MATCH_CRIT -lt 10 ] ;
1146        then line_0="default     "$MATCH_CRIT ;
1147        else line_0="default    "$MATCH_CRIT ; fi
1148        echo "$line_0" | tee -a $SUMMARY
1149        cat << EOF | tee -a $SUMMARY
1150    G D M    C  G
1151    E p a R  o  r
1152    N n k u  s  a
1153    2 d e n  t  d
1154    
1155  EOF  EOF
1156    fi
1157    
1158  NDIR=0  #  ...and each test directory...
1159    for dir in $TESTDIRS ; do
1160        
1161        # set builddir & rundir:
1162        builddir="build"
1163        if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi
1164        rundir="run"
1165        if test ! -d $dir/$rundir ; then
1166            rundir=$builddir
1167        fi
1168        CODE_DIR=$dir/$code_dir
1169        BUILD_DIR=$dir/$builddir
1170    
1171  #  For each optfile...      #  Cleanup only!
1172  for OPTFILE in $OPTFILES ; do      if test "x$CLEANUP" = xt ; then
1173            echo -n '  --- dir:' $BUILD_DIR ': '
1174            makeclean $BUILD_DIR
1175            rm -f $BUILD_DIR/$EXECUTABLE
1176            if test -d $dir/$rundir/CVS ; then
1177                echo -n '  --- dir:' $dir/$rundir ': '
1178                run_clean $dir/$rundir
1179            fi
1180            trdir=`( cd $dir ; find . -type d -name "tr_run.*" -print | sed 's/^.\///')`
1181            ttd=`echo $trdir | wc -w`
1182            if test $ttd != 0 ; then
1183                echo '  --- rm dir:' $trdir
1184                ( cd $dir ; rm -rf $trdir )
1185            fi
1186            continue
1187        fi
1188    
1189      OPTFILE=`pwd`"/$OPTFILE"      #  Verify that the testdir exists and contains previous
1190      if test ! -r $OPTFILE ; then      #  results in the correct location--or skip this directory!
1191          echo "Error: can't read optfile \"$OPTFILE\""      fout=$dir"/results/"$ref_outp
1192          exit 1      if test ! -r $fout ; then
1193            echo "can't read \"$fout\" -- skipping $dir"
1194            continue
1195      fi      fi
     echo  
     echo "OPTFILE=$OPTFILE" >> $SUMMARY  
     echo >> $SUMMARY  
       
     #  ...and each test directory...  
     for dir in $TESTDIRS ; do  
           
         #  Create an output dir for each OPTFILE/tdir combination  
         CDIR=$DRESULTS"/"$DRESULTS"_"$NDIR  
         mkdir $CDIR  
         CDIR=`pwd`"/$CDIR"  
1196    
1197          #  ...configue, make, run, and compare the output.      # Check for specific files for particular type of run
         echo "-------------------------------------------------------------------------------"  
         echo  
         echo "Experiment:  $dir"  
         echo  
         unset genmake makedepend make run  
         results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'  
         ( cd $dir/input; rm -f *.{o,f,c,F} *.[f,F]90 work* output.txt Make* make.log; )  
         if [ -r $dir/build ]; then  
             seperatebuilddir=1  
             builddir=build  
             rundir=build  
             ( cd $dir/build; ln -sf ../input/* . )  
         else  
             seperatebuilddir=0  
             builddir=input  
             rundir=input  
         fi  
1198    
1199          #  Verify that the testdir exists and contains previous      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then
1200          #  results in the correct location--or skip this directory!          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
1201          if test ! -r $dir"/results/output.txt" ; then          continue
1202              echo | tee $SUMMARY      fi
1203              echo "can't read \"$dir/results/output.txt\" -- skipping $dir" \      if test ! -r $dir"/input/eedata.mth" -a "x$MULTI_THREAD" = "xt" ; then
1204                  | tee $SUMMARY          echo "can't find \"$dir/input/eedata.mth\" -- skipping $dir"
1205              continue          continue
1206        fi
1207        if test "x$MPI" = "xt" -a "x$MULTI_THREAD" = "xt" ; then
1208          retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/input/eedata.mth"`
1209          if test $retv != 0 ; then
1210            echo "input/eedata.mth tiling misfit -- skipping $dir"
1211            continue
1212          fi
1213        fi
1214    
1215        #  Check whether there are "extra runs" for this testdir
1216        extra_runs=
1217        ex_run_dirs=`( cd $dir ; echo $inputdir.* )`
1218        #echo "ex_run_dirs='$ex_run_dirs'"
1219        for exd in $ex_run_dirs ; do
1220            name=`echo $exd | sed -e "s/$inputdir\.//"`
1221            refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1222            outf="$dir/results/$refExOut"
1223            if test -f $outf -a -r $outf ; then
1224              if test "x$MULTI_THREAD" = "xt" ; then
1225                if test -r $dir"/"$exd"/eedata.mth" ; then
1226                  if test "x$MPI" = "xt" ; then
1227                    retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/"$exd"/eedata.mth"`
1228                    if test $retv = 0 ; then
1229                        extra_runs="$extra_runs $name"
1230                    else
1231                        echo $exd"/eedata.mth tiling misfit -- skipping $dir"
1232                    fi
1233                  else
1234                    extra_runs="$extra_runs $name"
1235                  fi
1236                #else echo $dir"/"$exd"/eedata.mth: not found"
1237                fi
1238              else
1239                extra_runs="$extra_runs $name"
1240              fi
1241          fi          fi
1242        done
1243    
1244        echo "-------------------------------------------------------------------------------"
1245        echo
1246        if test "x$extra_runs" = "x" ; then
1247           echo "Experiment:  $dir"
1248        else
1249           echo "Experiment:  $dir ; extra_runs=$extra_runs"
1250        fi
1251        echo
1252        unset genmake makedepend make run
1253        results=$EMPTY_RESULTS
1254    
1255        #  Create an output dir for each OPTFILE/tdir combination
1256        rel_CDIR=$DRESULTS"/"$dir
1257        mkdir $rel_CDIR
1258        CDIR=`pwd`"/$rel_CDIR"
1259        
1260        if test "x$CLEANUP" = xt ; then
1261            echo '====>>> this is to check that we never go through this part <<< ==='
1262            makeclean $dir/$builddir \
1263                && run_clean $dir/$rundir
1264        else
1265          genmakemodel $dir/$builddir && genmake=Y \          genmakemodel $dir/$builddir && genmake=Y \
1266              && makeclean $dir/$builddir \              && makeclean $dir/$builddir \
1267                && run_clean $dir/$rundir \
1268                && symlink_mpifiles $dir $code_dir $builddir \
1269              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1270              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
1271              && linkdata $seperatebuilddir $dir/$rundir \              && linkdata $dir/$rundir $inputdir input \
1272              && runmodel $dir/$builddir mitgcmuv && run=Y \              && runmodel $dir/$rundir && run=Y \
1273              && results=`testoutput $dir $rundir`              && results=`testoutput_run $dir $rundir $ref_outp`
1274          echo      fi
1275          formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \      
1276              ${run:-N} $results      echo
1277            fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1278          echo          echo
1279          formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1280              ${run:-N} $results >> $SUMMARY          touch $CDIR"/summary.txt"
1281          echo "fresults='" > $CDIR"/summary.txt"          echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
         formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \  
             ${run:-N} $results >> $CDIR"/summary.txt"  
         echo "'" >> $CDIR"/summary.txt"  
1282          echo "MACH='$MACH'" >> $CDIR"/summary.txt"          echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1283          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1284          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1285          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1286            if test "x$ADM" = xt ; then
1287                head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1288                grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \
1289                                    >> $CDIR"/summary.txt"
1290            fi
1291    
1292          (          for ex in $extra_runs ; do
1293              cd $DRESULTS              unset run
1294              tar -cf $NDIR".tar" $DRESULTS"_"$NDIR > /dev/null 2>&1              results=$EMPTY_RESULTS
1295              gzip $NDIR".tar"              #  reference output file
1296          )              refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`
1297                #  Create an output dir for each OPTFILE/tdir.ex combination
1298                rel_CDIR=$DRESULTS"/"$dir"."$ex
1299                mkdir $rel_CDIR
1300                CDIR=`pwd`"/$rel_CDIR"
1301                test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"
1302                run_clean $dir/tr_run.$ex
1303                linkdata $dir/tr_run.$ex $inputdir.$ex $inputdir input
1304                runmodel $dir/tr_run.$ex && run=Y \
1305                && results=`testoutput_run $dir tr_run.$ex $refExOut`
1306                fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1307                fres="$fres.$ex"
1308                echo
1309                echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1310                touch $CDIR"/summary.txt"
1311                echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1312                echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1313                echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1314                echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1315                echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"
1316                if test "x$ADM" = xt ; then
1317                    head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1318                    grep -A3 'Seconds in section "ALL' $dir/tr_run.$ex/$OUTPUTFILE \
1319                                       >> $CDIR"/summary.txt"
1320                fi
1321                if test "x$POSTCLEAN" = xt ; then
1322                    run_clean $dir/tr_run.$ex
1323                fi
1324            done
1325    
1326          $MPACK -s MITgcm-test -m 1000000 $DRESULTS"/"$NDIR".tar.gz" $ADDRESSES      #postclean $dir/$builddir
1327        if test "x$POSTCLEAN" = xt ; then
1328            makeclean $dir/$builddir \
1329                && run_clean $dir/$rundir
1330        fi
1331        
1332        echo "-------------------------------------------------------------------------------"
1333        
1334    done
1335    
1336    printf "Start time:  " >> $SUMMARY
1337    echo "$start_date" >> $SUMMARY
1338    printf "End time:    " >> $SUMMARY
1339    date >> $SUMMARY
1340    
1341    #  If addresses were supplied and mpack built successfully, then try
1342    #  to send email using mpack.
1343    if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then
1344        echo "No results email was sent."
1345    else
1346        if test "x$HAVE_MPACK" = xt ; then
1347            tar -cf $DRESULTS".tar" $DRESULTS > /dev/null 2>&1 \
1348                && gzip $DRESULTS".tar" \
1349                && $MPACK -s MITgcm-test -m 3555000 $DRESULTS".tar.gz" $ADDRESSES
1350          RETVAL=$?          RETVAL=$?
1351          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1352              echo "Warning: \"$MPACK\" failed -- please contact <edhill@mitgcm.org>"              echo
1353                echo "Warning: The tar, gzip, & mpack step failed.  Please send email"
1354                echo "  to <MITgcm-support@mitgcm.org> for help.  You may copy the "
1355                echo "  summary of results from the directory \"$DRESULTS\"."
1356                echo
1357          else          else
1358              rm -f $DRESULTS"/"$NDIR".tar*"              echo
1359                echo "An email containing results was sent to the following addresses:"
1360                echo "  \"$ADDRESSES\""
1361                echo
1362                test -f $DRESULTS".tar"  &&  rm -f $DRESULTS".tar"
1363                test -f $DRESULTS".tar.gz"  &&  rm -f $DRESULTS".tar.gz"
1364          fi          fi
1365        fi
1366    fi
1367    
1368          NDIR=$(( $NDIR + 1 ))  rm -f tr_cmpnum.c tr_cmpnum
           
     done  
 done  
1369    
1370  rm tmp_cmpnum.f a.out  if test "x$CLEANUP" != xt ; then
1371        cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'
1372        if test -e tr_out.txt ; then
1373            mv tr_out.txt tr_out.txt.old
1374        fi
1375        cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/ \. //g' > tr_out.txt
1376    fi
1377    
1378  cat $SUMMARY  if test "x$DELDIR" = xt ; then
1379        rm -rf $DRESULTS
1380    fi
1381    

Legend:
Removed from v.1.2  
changed lines
  Added in v.1.130

  ViewVC Help
Powered by ViewVC 1.1.22